import { Renderer2D } from "./renderer";

export class CanvasApp{
    readonly gl: WebGL2RenderingContext;
    renderer: Renderer2D;
    constructor(gl: WebGL2RenderingContext){
        this.gl = gl;
        this.renderer = new Renderer2D(gl);
    }
    intialize():boolean{

        return true;
    }
    run(){
        const current = new Date();
        this.loop();
        const delta = (new Date().getMilliseconds()) - current.getMilliseconds();
        const delay = (delta < 16) ? (16 - delta) : 1;
        setTimeout((()=>{
            this.run();
        }).bind(this),delay);
    }
    loop(){
        this.gl.clearColor(0,0,0,0);
        this.gl.clear(this.gl.COLOR_BUFFER_BIT);
        this.renderer.draw();
    }
};